unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Grids, Vcl.StdCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    DataNoEdit: TLabeledEdit;
    DataNoSet: TButton;
    StringGrid1: TStringGrid;
    CalcBtn: TButton;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure DataNoSetClick(Sender: TObject);
    procedure CalcBtnClick(Sender: TObject);
    procedure Area_Calc;            //  ʐόvZ
  private
    { Private 錾 }
    procedure DataNumberset;        // StringGrid1̐ݒ
    procedure Graph;                // }`\
    function Cross_Check(Xs1, Ys1, Xe1, Ye1, Xs2, Ys2, Xe2, Ye2: Double): Boolean;   // `FbN
    function Data_Check: Boolean;           // ̓f[^[mF
    function Cross3Check: Boolean;          // O_AƁǍ`FbN
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses System.Math;

var
  N     : Integer;                  // f[^[̐
  Xd    : array of double;          // wW
  Yd    : array of double;          // xW
  S     : Double;                   // ʐ
  Xmin  : Double;
  Xmax  : Double;
  Ymin  : Double;
  Ymax  : Double;
  Scale : Double;
  GsMax : Double;             // 莞̌덷ɂꌟmh~p

// O_AƁǍ`FbN
function TForm1.Cross3Check: Boolean;
label
  che;
var
  M : integer;
  i, c, j, k, l : Integer;
  o             : Integer;
  Q1, Q2, Q3    : Double;
  Li, Lj        : Double;
  Yic, Yjc      : Double;
  CF, DF        : Boolean;
  a1, a2        : Double;
  c1, c2        : Double;
  xc, yc        : Double;
  XF, YF        : Boolean;
begin
  Result := True;
  a1 := 0;
  a2 := 0;
  yc := 0;
  xc := 0;
  c1 := 0;
  c2 := 0;
  if N < 5 then exit;
  M := N -1;
  for i := 0 to M do begin
    c := i + 1;                                 // ̕i,c
    if c > M then c := c - M - 1;
    j := c + 1;                                 // ̕c,j
    if j > M then j := j - M - 1;
    // i + 3  ͂R_A̎̓_ M + i - 1  R_A̓O
    for o := i + 3 to M + i - 1 do begin
      CF := False;                              // tO
      DF := False;
      k := o;
      if k > M then k := k - M - 1;             // Ώەk,l
      l := k + 1;
      if l > M then l := l - M - 1;

      if Xd[i] = Xd[c] then CF := true                      // ŏ̕X[tO 
                       else a1 := (Yd[i] - Yd[c]) / (Xd[i] - Xd[c]);
      if Xd[k] = Xd[l] then DF := true                      // ΏەX[tO 
                       else a2 := (Yd[k] - Yd[l]) / (Xd[k] - Xd[l]);

      // X a ̒lvZłA萔@C ̒lvZ
      if not CF then c1 := Yd[c] - a1 * Xd[c];
      if not DF then c2 := Yd[l] - a2 * Xd[l];

      // s̏ꍇ
      if CF and DF then goto Che;       // Ȃ̂ō܂

      // ӂƂX a vZ
      if not CF and not DF then begin
        if a1 = a2 then goto Che;       // X΂ꍇsȂ̂ō܂
        xc := (c2 - c1) / (a1 - a2);    // _X̌vZ
        yc := a1 * Xc + c1;             // _Y̌vZ
      end;
      // ŏ̕Ӑ̏ꍇ _vZ
      if CF and not DF then begin
        xc := Xd[i];                  // ŏ̕Ӑ ŏ̕ӂw̒l
        yc := a2 * xc + c2;           // _Y̌vZ
      end;
      // Ώۂ̕Ӑ̏ꍇ _vZ
      if DF and not CF then begin
        xc := Xd[k];                  // ΏەӐ ΏەX̒l
        yc := a1 * xc + c1;           // _Y̌vZ
      end;
      // _ŏ̓ӂ̋ʓ_ƈvȂ獟܂ 1e-10 ͉Z덷
      if (abs(xc - Xd[c]) > 1e-10) or  (abs(yc - Yd[c]) > 1e-10) then goto che;

      XF := False;                    // ӏ̓_̔tO
      YF := False;

      // Xc  yc  Ώەӂ ͈͓mF
      // X mF
      if Xd[l] = Xd[k] then XF := True
      else begin
        if Xd[l] > Xd[k] then begin
          if (Xd[c] > Xd[k]) and  (Xd[l] > Xd[c]) then XF := True;
        end
        else
          if (Xd[c] < Xd[k]) and  (Xd[l] < Xd[c]) then XF := True;
      end;
      // y@mF@
      if Yd[l] = Yd[k] then YF := True
      else begin
        if Yd[l] > Yd[k] then begin
          if (Yd[c] > Yd[k]) and  (Yd[l] > Yd[c]) then YF := True;
        end
        else
          if (Yd[c] < Yd[k]) and  (Yd[l] < Yd[c]) then YF := True;
      end;
      // ͈͓Wϊ O_2ӂ̗[̓_W@Ώەӂ̊pxŐ֍Wϊ
      if XF and YF then begin
        Q1 := arctan2(Yd[c] - Yd[i], Xd[c] - Xd[i]);
        Q2 := arctan2(Yd[c] - Yd[j], Xd[c] - Xd[j]);
        Q3 := arctan2(Yd[l] - Yd[k], Xd[l] - Xd[k]);
        Li := sqrt((Yd[c] - Yd[i]) * (Yd[c] - Yd[i]) + (Xd[c] - Xd[i]) * (Xd[c] - Xd[i]));
        Lj := sqrt((Yd[j] - Yd[c]) * (Yd[j] - Yd[c]) + (Xd[j] - Xd[c]) * (Xd[j] - Xd[c]));
        Yic := sin(Q1 - Q3) * Li;
        Yjc := sin(Q2 - Q3) * Lj;
        if abs(Yic) < 1e-10 then Yic := 0;  // 1e-10 ͉Z덷
        if abs(Yjc) < 1e-10 then Yjc := 0;  // 1e-10 ͉Z덷
        // O_2ӂ̗[̓_W x@vXƃ}CiXɂ
        if ((Yic > 0) and (Yjc < 0)) or ((Yic < 0) and (Yjc > 0)) then Result := False;
      end;
che:
    end;
  end;
//  if not Result then Application.MessageBox('Ăӂ܂B','', 0);
end;

// W_ԒĂȂmF܂
// Ȃ True  False
function TForm1.Cross_Check(Xs1, Ys1, Xe1, Ye1, Xs2, Ys2, Xe2, Ye2: Double): Boolean;  // `FbN
var
  a1, a2  : Double;           // XΊp
  c1, c2  : Double;
  af1,af2 : Boolean;
  Xa      : Double;           // X̒l
  Ya      : Double;           // Y̒l
  f1,  f2 : Boolean;
begin
  Result := True;             // ߂lݒKv
  af1 := False;               // ӂPӃtO False ݒKv
  af2 := False;               // ӂQӃtO False ݒKv
  f1  := true;                // ӂP_ȂtOݒKv
  f2  := true;                // ӂQ_ȂtOݒKv
  a1 := 1000;                 // ӂPX
  a2 := 1000;                 // ӂQX
  Xa := 0;                    // _wW
  Ya := 0;                    // _YW
  c1 := 0;                    // ӂP萔
  c2 := 0;                    // ӂQ萔
  // ꎟ@Y = aX + C  a ̒lvZ W Xs Xe̒lꍇ a ̒l
  // Ȃ̂ŃtOZbg܂B
  if Xe1 = Xs1 then af1 := true                      // X1[tO 
               else a1 := (Ye1 - Ys1) / (Xe1 - Xs1);
  if Xe2 = Xs2 then af2 := true                      // X2[tO 
               else a2 := (Ye2 - Ys2) / (Xe2 - Xs2);
  // s̏ꍇ
  if af1 and af2 then exit;     // Ȃ̂ō܂

  // ӂƂX a vZ
  if not af1 and not af2 then
    if a1 = a2 then exit;       // X΂ꍇsȂ̂ō܂

  // X a ̒lvZłA萔@C ̒lvZ
  if not af1 then c1 := Ys1 - a1 * Xs1;
  if not af2 then c2 := Ys2 - a2 * Xs2;

  // ̏ꍇ _@X ̒l
  if af1 then Xa := Xs1;        // 1 X1̍Wl _X̒l
  if af2 then Xa := Xs2;        // 2 X2̍Wl _X̒l

  // _ӂ͈͓̔`FbN
  // _ f  False ɃZbg
  // Ƃłsłꍇ
  if not af1 and not af2 then begin
    Xa := (c2 - c1) / (a1 - a2);              // _X̒lvZ
    // ӂP`FbN
    if Ys1 = Ye1 then begin
      if (Ys2 = Ys1) or (Ye2 = Ys1) then exit;
    end;
    if Xs1 < Xe1 then begin
      if (Xa > Xs1) and (Xa < Xe1) then f1 := False;
    end
    else
      if (Xa < Xs1) and (Xa > Xe1) then f1 := False;

    // ӂQ`FbN
    if Ys2 = Ye2 then begin
      if (Ys1 = Ys2) or (Ye1 = Ys2) then exit;
    end;
    if Xs2 < Xe2 then begin
      if (Xa > Xs2) and (Xa < Xe2) then f2 := False;
    end
    else
      if (Xa < Xs2) and (Xa > Xe2) then f2 := False;
    // _Ɣ肳ꂽ߂l False ɐݒ
    if not f1 and not f2 then Result := False;
    exit;
  end;
  // 1̏ꍇ
  if af1 then
    if (Xs2 = Xa) or (Xe2 = Xa) then exit;  // ӂQ̗[_̂ŵǂ炩XaƓ獟܂
  // 2̏ꍇ
  if af2 then
    if (Xs1 = Xa) or (Xe1 = Xa) then exit;  // ӂP̗[_̂ŵǂ炩XaƓ獟܂
  // Е̏ꍇ Y ̒lmF
  f1 := True;
  f2 := True;
  // X ̒lY ̒lvZ
  if not af1 then Ya := a1 * Xa + c1;
  if not af2 then Ya := a2 * Xa + c2;
  // ӂPmF
  if Ys1 < Ye1 then begin
    if (Ya > Ys1) and (Ya < Ye1) then f1 := False;
  end
  else
    if (Ya > Ye1) and (Ya < Ys1) then f1 := False;
  // ӂQmF
  if Ys2 < Ye2 then begin
    if (Ya > Ys2) and (Ya < Ye2) then f2 := False;
  end
  else
    if (Ya > Ye2) and (Ya < Ys2) then f2 := False;
  // _Ɣ肳ꂽ߂l False ɐݒ
  if not f1 and not f2 then Result := False;
end;

function TForm1.Data_Check: Boolean;        // ̓f[^[mF
var
  i, j, k : Integer;
begin
  Result := true;                          // ߂lݒ
  for i := 0 to N - 2 do                    // N - 1 Ō̓_Ȃ̂ł̂PO܂Ń[v
    for k := i + 2 to N - 1 do begin        // i + 2 Ō̓_܂Ń[v (i + 1̓_͓Ӌʓ_Ȃ̂ŌȂ)
      if k < N - 1 then j := k + 1          // Ō̓_łȂ玟̓_͈
                   else j := 0;             // Ō̓_A̓_͍ŏ̓_
      // ӂ̌`FbN True ŌȂ
      if i <> j then                        // i  j Ɠӂ̋ʓ_Ȃ̂ŌȂ
        Result := Cross_Check(Xd[i], Yd[i], Xd[i + 1], Yd[i + 1], Xd[k], Yd[k], Xd[j], Yd[j]);
      if not Result then exit;
    end;
end;

procedure TForm1.Graph;             // }`\
var
  j,m     : Integer;
  Xdiff : Double;
  Ydiff : Double;
  Xp,Yp : Integer;
begin
  // O̐}`
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Canvas.FillRect(Rect(0, 0, Image1.Width, Image1.Height));
  // ŏlől
  Xmin := MinValue(Xd);
  Xmax := MaxValue(Xd);
  Ymin := MinValue(Yd);
  Ymax := MaxValue(Yd);
  // ͈͌vZ
  Xdiff := Xmax - Xmin;
  Ydiff := Ymax - Ymin;
  // \XP[ݒ
  if Xdiff > Ydiff then begin
    GsMax := Xdiff;
    Scale := 250 / Xdiff;
  end
  else begin
    GsMax := Ydiff;
    Scale := 250 / Ydiff;
  end;
  // ӂ̂ƍW_̍}
  for j := 0 to N do begin                          // j  NɂȂŏ̍W_
    if j = N then m := 0                            // ̔z̍ŏ̒l
             else m := j;                           // ʏ̍W
    Xp :=  50 + Round((Xd[m] - Xmin) * Scale);      // ẌʒuvZ
    Yp := 350 - Round((Yd[m] - Ymin) * Scale) - 50; // ŸʒuvZ
    Image1.Canvas.Pen.Style := psSolid;
    Image1.Canvas.Pen.Color := clBlue;
    Image1.Canvas.Pen.Width := 1;
    if j = 0 then Image1.Canvas.MoveTo(Xp, Yp)      // ŏ̓_ֈړ
             else Image1.Canvas.LineTo(Xp, Yp);     // ŏ̓_łȂ
    if j < N then begin                             // ŏ̓_ɖ߂ĂȂs
      Image1.Canvas.Pen.Color := clBlack;
      Image1.Canvas.Brush.Color := clRed;
      Image1.Canvas.Ellipse(Xp - 2, Yp - 2, Xp + 3, Yp + 3);  // ~`撆hԂ
    end;
  end;
end;

// ʐόvZ    1/2(Xk - Xk+1)(Yk + Yk+1)
procedure TForm1.Area_Calc;
var
  K : Integer;
  J : Integer;
begin
  S := 0;
  for K := 0 to N -1 do begin
    if K < N - 1 then J := K + 1                  // ̍W j = k + 1
                 else J := 0;                     // Ō̍WɂȂ ̍W͍ŏ̍W j = 0
    S := S + (Xd[K] - Xd[J]) * (Yd[K] + Yd[J]);   // (Xk - Xj)(Yk + Yj)
  end;
  S := Abs(S / 2);                                // 1/2 ɂĐΒl
  Form1.Canvas.TextOut(50, 15, 'ʐρ                                   ');
  Form1.Canvas.TextOut(50, 15, 'ʐρ ' + floatTostr(S));
  Graph;                                          // }`\
end;

procedure TForm1.CalcBtnClick(Sender: TObject);   // ̓f[^[  ʐόvZ ӂ̌mF
var
  Check : Integer;
  I     : Integer;
  Cmt   : Pchar;
begin
  for I := 0 to N - 1 do begin
    Val(StringGrid1.Cells[1, I + 1], Xd[I], Check);
    if Check <> 0 then begin
      Cmt := PChar('wf[^[' + intTostr(I + 1) + 'ԖڂɊԈႢ܂');
      Application.MessageBox(Cmt,'', 0);
      Break;
      exit;
    end;
  end;
  for I := 0 to N - 1 do begin
    Val(StringGrid1.Cells[2, I + 1], Yd[I], Check);
    if Check <> 0 then begin
      Cmt := PChar('xf[^[' + intTostr(I + 1) + 'ԖڂɊԈႢ܂');
      Application.MessageBox(Cmt,'', 0);
      Break;
      exit;
    end;
  end;
  Area_Calc;                      // ʐόvZ
  if not Data_Check then          // ӂ̌mF
    Application.MessageBox('Ăӂ܂B','', 0);
  if not Cross3Check then
    Application.MessageBox('Ăӂ܂B','', 0);
end;

procedure TForm1.DataNumberset;   // StringGrid1̐ݒ XYz̊m
var
  K : Integer;
begin
  Val(DataNoEdit.Text, N, K);     // f[^[̐@lϊ
  if K <> 0 then begin
    Application.MessageBox('f[^[̐ɊԈႢ܂','', 0);
    exit;
  end;
  if N < 3 then begin
    Application.MessageBox('f[^[̐͂R͂RȏɂĉB','', 0);
    exit;
  end;
  K := 3;                         //  3
  StringGrid1.Width := (StringGrid1.DefaultColWidth + 1) * K  + 3;
  if N < 11 then begin            // f[^[11ȉ̏ꍇ
    StringGrid1.ScrollBars := ssNone;
    K := N + 1;                   // s N + 1
    StringGrid1.Height := (StringGrid1.DefaultRowHeight + 1) * K + 3;
  end else
  begin
    K := 11;                      // s 10 + 1
    StringGrid1.ScrollBars := ssVertical;
    StringGrid1.Width := StringGrid1.Width + 18;
    StringGrid1.Height := (StringGrid1.DefaultRowHeight + 1) * K + 3;
  end;
  StringGrid1.RowCount := N + 1;  // sZbg
  for K := 1 to N + 1 do          // f[^[ԍObhɕ\
    StringGrid1.Cells[0 , K] := InttoStr(K);
  SetLength(Xd, N);               // XWz̊m
  SetLength(Yd, N);               // yWz̊m
end;

procedure TForm1.DataNoSetClick(Sender: TObject);
begin
  DataNumberset;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  BitMapD : Tbitmap;
begin
  ClientHeight := 410;
  ClientWidth  := 840;
  StringGrid1.Cells[0 , 0] := '';
  StringGrid1.Cells[1 , 0] := 'X';
  StringGrid1.Cells[2 , 0] := 'Y';
// ************* eXgf[^[ ************
  DataNoEdit.Text := '5';
  StringGrid1.Cells[1 , 1] := '0';
  StringGrid1.Cells[2 , 1] := '0';
  StringGrid1.Cells[1 , 2] := '20';
  StringGrid1.Cells[2 , 2] := '0';
  StringGrid1.Cells[1 , 3] := '10';
  StringGrid1.Cells[2 , 3] := '10';
  StringGrid1.Cells[1 , 4] := '20';
  StringGrid1.Cells[2 , 4] := '20';
  StringGrid1.Cells[1 , 5] := '0';
  StringGrid1.Cells[2 , 5] := '20';
// *****************************************
  DataNumberset;
  Image1.Width  := 350;
  Image1.Height := 350;
  BitMapD := Tbitmap.Create;
  BitMapD.Width := Image1.Width;
  BitMapD.Height := Image1.Height;
  Image1.Picture.Graphic := BitMapD;
  BitMapD.Free;
end;

end.
